=== debian/changelog ===
iem-plugin-suite (1.15.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Sat, 12 Apr 2025 07:04:12 +0200

iem-plugin-suite (1.15.0-2~exp1) experimental; urgency=medium

  * Ship VST3 plugins in separate package

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 11 Apr 2025 07:56:59 +0200

iem-plugin-suite (1.15.0-1) unstable; urgency=medium

  * New upstream version 1.15.0
  * iem-plugin-suite-vst: install VST3 plugins
  * B-D on libgl-dev instead of libgl1-mesa-dev
  * Add verbatim copy of 'ht-api-juce'
    + a to-be-vendored 'Head Tracker API for C++/JUCE' library
    + Add license information for "Head Tracker API for C++/JUCE"
    + Include ht-api-juce into build-tree
    + Allow PNG in verbatim copy of supperware's ht-api-juce
  + Add README for debian/missing-sources
  * Update d/copyright
    + Re-generate d/copyright_hints
    + Bump copyright dates
  * Apply 'wrap-and-sort -ast'
  * Fix d/watch
  * Bump standards version to 4.7.2

 -- IOhannes m zmölnig (Debian/GNU) <umlaeute@debian.org>  Fri, 11 Apr 2025 07:45:43 +0200
