=== debian/watch ===
# to be processed with uscan(1)

version=4
opts=\
 searchmode=plain,\
 uversionmangle=s/-/./g,\
 dversionmangle=auto \
 https://git.iem.at/audioplugins/IEMPluginSuite/tags?sort=updated_desc -/archive/v?\d[\d.-]+/IEMPluginSuite-@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
